<?php
//Fonction executée lors de l'activation du plugin
function customiser_install($id){
	if($id != 'fr.idleman.customiser') return;
	Entity::install(__DIR__);
}

//Fonction executée lors de la désactivation du plugin
function customiser_uninstall($id){
	if($id != 'fr.idleman.customiser') return;
	Entity::uninstall(__DIR__);
}

//Déclaration des sections de droits du plugin
function customiser_section(&$sections){
	$sections['customiser'] = "Gestion des droits sur le plugin customiser";
}

//Cette fonction comprends toutes les actions 
//du plugin qui ne nécessitent pas de vue html
function customiser_action(){
	require_once(__DIR__.SLASH.'action.php');
}

//Déclaration du menu de réglages
function customiser_menu_setting(&$settingMenu){
	global $_, $myUser;
	
	if(!$myUser->can('customiser','configure')) return;
	$settingMenu[]= array(
		'sort' =>1,
		'url' => 'setting.php?section=global.customiser',
		'icon' => 'fas fa-angle-right',
		'label' => 'Thème'
	);
}

//Déclaration des pages de réglages
function customiser_content_setting(){
	global $_;
	if(file_exists(__DIR__.SLASH.'setting.'.$_['section'].'.php'))
		require_once(__DIR__.SLASH.'setting.'.$_['section'].'.php');
}

global $conf;
if(!empty($conf->get('core_theme'))){

	Plugin::addCss(str_replace('plugin/customiser','',$conf->get('core_theme')),true); 
}
//Déclation des assets
if(file_exists(__DIR__.SLASH.'css'.SLASH.'theme.css'))
Plugin::addCss("/css/theme.css?v=".filemtime(__DIR__.SLASH.'css'.SLASH.'theme.css')); 
Plugin::addCss("/css/main.css"); 
Plugin::addJs("/js/main.js"); 

//Mapping hook / fonctions
Plugin::addHook("install", "customiser_install");
Plugin::addHook("uninstall", "customiser_uninstall"); 
Plugin::addHook("section", "customiser_section");
Plugin::addHook("action", "customiser_action");  
Plugin::addHook("menu_setting", "customiser_menu_setting");    
Plugin::addHook("content_setting", "customiser_content_setting");   
 

?>