<?php


//Déclaration d'un item de menu dans le menu principal
function git_menu(&$menuItems){
	global $_,$myUser;
	if(!$myUser->can('git','read')) return;
	$menuItems[] = array(
		'sort'=>3,
		'url'=>'index.php?module=git',
		'label'=>'git',
		'icon'=> 'far fa-question-circle',
		'color'=> '#3498db'
	);
}

//Cette fonction va generer une page quand on clique sur git dans menu
function git_page(){
	global $_,$myUser;
	if(!isset($_['module']) || $_['module'] !='git') return;
	$page = !isset($_['page']) ? 'list.git.repository' : $_['page'];
	$file = __DIR__.SLASH.'page.'.$page.'.php';
	if(!file_exists($file)) throw new Exception("Page ".$page." inexistante");
	
	require_once($file);
}

//Fonction executée lors de l'activation du plugin
function git_install($id){
	if($id != 'fr.idleman.git') return;
	Entity::install(__DIR__);
	global $conf;
	$conf->put('hackpoint_resource_part',true);
}

//Fonction executée lors de la désactivation du plugin
function git_uninstall($id){
	if($id != 'fr.idleman.git') return;
	Entity::uninstall(__DIR__);
}

//Déclaration des sections de droits du plugin
function git_section(&$sections){
	$sections['git'] = "Gestion des droits sur le plugin git";
	// $sections['gitrepository'] = "Gestion des droits sur l'entité gitrepository";
}

//cette fonction comprends toutes les actions du plugin qui ne nécessitent pas de vue html
function git_action(){
	require_once(__DIR__.SLASH.'action.php');
}


 function git_manage_types(&$types){
 	$types[] = __DIR__.SLASH.'GitType.class.php';
 }




  


//Déclation des assets
Plugin::addCss("/css/main.css"); 
Plugin::addJs("/js/main.js"); 

//Mapping hook / fonctions
Plugin::addHook("install", "git_install");
Plugin::addHook("uninstall", "git_uninstall"); 
Plugin::addHook("section", "git_section");
Plugin::addHook("menu_main", "git_menu"); 
Plugin::addHook("page", "git_page");  
Plugin::addHook("action", "git_action");  
    
 Plugin::addHook("hackpoint_resource_type", "git_manage_types");   
    

?>