<?php
global $myUser;
User::check_access('issue','configure');
require_once(__DIR__.SLASH.'IssueReport.class.php');
require_once(__DIR__.SLASH.'IssueReportTag.class.php');

$browsers = array(
    'opera' => 'Opera',
    'firefox' => 'Mozilla Firefox',
    'chrome' => 'Google Chrome',
    'safari' => 'Safari',
    'ie' => 'Internet Explorer',
    'edge' => 'Microsoft Edge',
    'blink' => 'Blink'
);
$states = array();
foreach(IssueReport::states() as $slug=>$state)
    $states[$slug] = $state['label'];

$tags = IssueReportTag::tags();
?>

<div class="row">
    <div class="col-xl-12 tab-container parent-tab mb-3 noPrint">
        <h3>Réglages Tickets</h3>
       
        <ul class="nav nav-tabs" role="tablist">
            <li class="nav-item"><a data-toggle="tab" class="nav-link active" href="#tab-reports" aria-controls="tab-reports" aria-selected="true">Listing des rapports</a></li>
            <li class="nav-item"><a data-toggle="tab" class="nav-link" href="#tab-settings" aria-controls="tab-settings" aria-selected="false">Paramètres</a></li>
        </ul>
    </div>

    <div class="tab-content col-xl-12">
        <!-- Onglet Listing des rapports -->
        <div class="tab-pane show active in" id="tab-reports" role="tabpanel" aria-labelledby="tab-reports">
            
            <div class="issue-reports-search mb-2">
                <select id="filters" data-join="and" data-slug="issue_search" data-type="filter" data-label="Recherche" data-function="issue_issuereport_search">
                    <option value="state" data-filter-type="dictionnary" data-filter-source='<?php echo json_encode($states); ?>'>Etat</option>
                    <option value="from" data-filter-type="text">Url</option>
                    <option value="comment" data-filter-type="text">Commentaire</option>
                    <option value="{{table}}.creator" data-filter-type="user">Auteur</option>
                    <option value="{{table}}.created" data-filter-type="date">Date</option>
                    <option value="browser" data-filter-type="dictionnary" data-filter-source='<?php echo json_encode($browsers); ?>'>Navigateur</option>
                    <option value="ip" data-filter-type="text">Adresse IP</option>
                </select>
                <div>
                    <label class="-d-inline-block mt-1 mb-1">Tags :</label>
                    <input type="text" onchange="issue_issuereport_search()" data-tags='<?php echo json_encode($tags); ?>' id="report-tags" data-type="tagcloud">
                </div>
            </div>

          
            <ul id="issuereports" class="list-issue-reports" data-entity-search="issue_issuereport_search">
                
                    <li data-id="{{id}}" class="hidden">
                       <a>
                       <div class="issue-state">
                            <i class="{{state.icon}}" style="color: {{state.color}};" title="{{state.label}}"></i>
                        </div>
                        <div class="infos-cell text-left">
                            <a  class="issue-title" title="Voir le rapport détaillé" href="index.php?module=issue&page=sheet.report&id={{id}}">
                                <span class="font-weight-bold d-inline-block mb-1">{{excerpt}}</span>
                            </a>
                            {{#assign}}<span class="assign"> Assigné à <i class="ml-1 far fa-meh-blank"></i> {{assign}}</span>{{/assign}}
                            <div class="mb-1 mt-2 text-muted">
                                <a class="pointer font-weight-bold  mr-2" onclick="$(this).parent().next('div').slideToggle(150)" title="Afficher plus de détails">#{{id}}</a> <i class="far fa-calendar"></i> {{date}} <i class="far fa-clock ml-2"></i> {{hour}} par <span class=""><i class="far fa-meh-blank"></i> {{creator}}</span> 
                                <ul class="report-tag ml-2">
                                    {{#tags}}
                                        <li>
                                            <span class="badge badge-tag no-select" style="background-color:{{color}}; border:1px solid {{color}};color:#ffffff;"><i class="{{icon}}"></i> {{label}}</span>
                                        </li>
                                    {{/tags}}
                                </ul>
                            </div>
                            <div class="hidden">
                                <span> Page : <a title="Accéder à la page" href="<?php echo ROOT_URL; ?>{{relativefrom}}" target="_blank">{{relativefrom}}</a></span><br>
                                <small class="text-muted mb-2 d-block">IP: {{ip}}</small>
                                <div>
                                    <span class="mr-1"><i class="{{browserIcon}}"></i> {{browser}}</span>|
                                    <span class="ml-1 mr-1"><i class="{{osIcon}}"></i> {{os}}</span>|
                                    <span class="ml-1"><i class="fas fa-tv"></i> {{width}}px * {{height}}px</span>
                                </div>
                                <small class="text-muted">{{browserVersion}}</small>
                            </div>
                        </div>
                        
                        <div class="report-buttons">
                            {{#comments}}<i title="{{comments}} Commentaire(s)" class="fas fa-comment text-muted btn-comments"></i> {{comments}}{{/comments}}

                            <i class="far fa-trash-alt pointer btn-delete text-muted"  title="Supprimer le rapport" onclick="issue_issuereport_delete(this);"></i>
                        </div>
                    </li>
              
            </ul>

             <!-- Pagination -->
            <ul class="pagination justify-content-center">
                <li class="page-item hidden" data-value="{{value}}" title="Voir la page {{label}}" onclick="$(this).parent().find('li').removeClass('active');$(this).addClass('active');issue_issuereport_search();">
                    <a class="page-link" href="#">{{label}}</a>
                </li>
            </ul>
        </div>

        <!-- Onglet Paramètres -->
        <div class="tab-pane" id="tab-settings" role="tabpanel" aria-labelledby="tab-settings">
            <div class="row">
                <div class="col-md-12">
                    <div onclick="issue_setting_save();" class="btn btn-success float-right"><i class="fas fa-check"></i> Enregistrer</div>
                    <legend>Paramètres généraux :</legend>
                    <div class="clear"></div>
                </div>
            </div>
            <?php echo Configuration::html('issue'); ?>
        </div>
    </div>
</div>
