<?php


//Déclaration d'un item de menu dans le menu principal
function part_menu(&$menuItems){
	global $_,$myUser;
	if(!$myUser->can('part','read')) return;
	$menuItems[] = array(
		'sort'=>3,
		'url'=>'index.php?module=part&page=list.part',
		'label'=>'Composants',
		'icon'=> 'fas fa-microchip',
		'color'=> '#3498db'
	);
}

//Cette fonction va generer une page quand on clique sur part dans menu
function part_page(){
	global $_,$myUser;
	if(!isset($_['module']) || $_['module'] !='part') return;
	$page = !isset($_['page']) ? 'list.part' : $_['page'];
	$file = __DIR__.SLASH.'page.'.$page.'.php';
	if(!file_exists($file)) throw new Exception("Page ".$page." inexistante");
	
	require_once($file);
}

//Fonction executée lors de l'activation du plugin
function part_install($id){
	if($id != 'fr.idleman.part') return;
	global $conf;
	Entity::install(__DIR__);
	$conf->put('hackpoint_resource_part',true);
}

//Fonction executée lors de la désactivation du plugin
function part_uninstall($id){
	if($id != 'fr.idleman.part') return;
	global $conf;
	Entity::uninstall(__DIR__);
	$conf->put('hackpoint_resource_part',false);
}

//Déclaration des sections de droits du plugin
function part_section(&$sections){
	$sections['part'] = "Gestion des droits sur le plugin part";
}

//cette fonction comprends toutes les actions du plugin qui ne nécessitent pas de vue html
function part_action(){
	require_once(__DIR__.SLASH.'action.php');
}

//Déclaration du menu de réglages
function part_menu_setting(&$settingMenu){
	global $_, $myUser;
	
	if(!$myUser->can('part','configure')) return;
	/*	$settingMenu[]= array(
		'sort' =>1,
		'url' => 'setting.php?section=global.part',
		'icon' => 'fas fa-angle-right',
		'label' => 'Composants'
	);*/

}

//Déclaration des pages de réglages
function part_content_setting(){
	global $_;
	if(file_exists(__DIR__.SLASH.'setting.'.$_['section'].'.php'))
		require_once(__DIR__.SLASH.'setting.'.$_['section'].'.php');
}


//Déclaration des settings de base
//Types possibles : text,select ( + "values"=> array('1'=>'Val 1'),password,checkbox. Un simple string définit une catégorie.
Configuration::setting('part',array(
        "Général",
        'part_enable' => array("label"=>"Activer","type"=>"checkbox"),
));


 function part_manage_types(&$types){
 	$types[] = __DIR__.SLASH.'PartType.class.php';
 }


//Déclation des assets
Plugin::addCss("/css/main.css"); 
Plugin::addCss("/css/component.css?v=1",true); 

Plugin::addJs("/js/component.js?v=2",true); 
Plugin::addJs("/js/main.js"); 

//Mapping hook / fonctions
Plugin::addHook("install", "part_install");
Plugin::addHook("uninstall", "part_uninstall"); 
Plugin::addHook("section", "part_section");
Plugin::addHook("menu_main", "part_menu"); 
Plugin::addHook("page", "part_page");  
Plugin::addHook("action", "part_action");  
Plugin::addHook("menu_setting", "part_menu_setting");    
Plugin::addHook("content_setting", "part_content_setting");   
Plugin::addHook("hackpoint_resource_type", "part_manage_types"); 

?>